/**
  ******************************************************************************
  * @file           : main.c
  * @author         : SINOMCU-AE
  * @brief          : Main program body
  *    
  *          This file provides example code for WWDG reset and printf by uart:
  * WWDG 20ms,window 10ms,main function loop refresh ~5s,WWDG reset LED2 light on 5s.
  * uart send information of running count(redirect printf),defualt period 0.5s.
  * For details, see "readme.txt"    
  *         
  ******************************************************************************
   * @attention 
  *                           DISCLAIMER
  * The present firmware which is for guidance only aims at providing customers
  * with coding information regarding their products in order for them to save
  * time. As a result, SinoMCU shall not be held liable for any direct,indirect
  * or consequential damages with respect to any claims arising from the content 
  * of such firmware and/or the use made by customers of the coding information 
  * contained herein in connection with their products.
  *
  * <h2><center>&copy; Copyright (c) 2021 sinomcu All rights reserved.</center></h2>
  *
  ******************************************************************************
  */  
  
#include "system_define.h"

#define COUNT_PERIOD             500        // unit ms
#define WWDG_RESET_DELAY_5S      5000       // unit ms

/**
  * @brief  Main program
  * @param  None
  * @retval None
  */
int main(void) {
  uint32_t count=0;
  uint32_t LED_blink_Time = COUNT_PERIOD;
  uint32_t reset_flag =0;
  uint16_t refresh_WWDG_count =0;
  
  //MS32_DBGMCU_APB1_GRP1_FreezePeriph(MS32_DBGMCU_APB1_GRP1_WWDG_STOP);  

  reset_flag= MS32_RCC_GetResetFlag(ENABLE);               // get reset source and clear
#if(defined(SYSCLK_USE_PLL_48M) && SYSCLK_USE_PLL_48M)     // SYSCLK_USE_PLL_48M,WWDG_CFG.h
  sysclk_init();                                           // sysclk 48M,HSI/2 *12;if not call this function,default HSI 8M
#endif
  SystemCoreClockUpdate();                                 // get System Core Clock
    
  sys_tick_init();
  gpio_init();

#if(defined(EN_PRINT_UART) && EN_PRINT_UART)   
  MS32_RCC_SetUSARTClockSource(MS32_RCC_USART1_CLKSOURCE_HSI);  // uart clk HSI 8M  
  usart1_uart_init(115200);
#endif
  LED1_ON(); 
  
  printf("\r\n\r\n*****WWDT Example*****");
  printf("\r\n--Inf:System Core Clock %d Hz.",SystemCoreClock);
  
  if(reset_flag & MS32_RCC_FLAG_WWDGRSTF) {                // WWDT reset occur
    LED2_ON(); 
    printf("\r\n--Inf:!!!Reset source include WWDT,delay 5S!"); 
    MS32_mDelay(WWDG_RESET_DELAY_5S);   
    LED2_OFF(); 
  }  
  
  wwdg_init();   
  Start_User_MS_SF_Timer(LED_blink_Time);
  while(1) {
    if(refresh_WWDG_count < REFRESH_WWDG_5S ) {            // refresh WWDG 5S
      if( MS32_WWDG_GetCounter( WWDG ) < WWDG_WIN_USER) {  // just example for refresh WWDG,You have a better way to use it in the project
        MS32_WWDG_Refresh(WWDG_CNT_USER);
        refresh_WWDG_count++;
      }
    }
    
    if(Get_State_User_MS_SF_Timer() == SF_TIMER_OV) {
      Start_User_MS_SF_Timer(LED_blink_Time);              // clear soft timer ov
      LED1_TOGGLE();
      count++;
      printf("\r\n--Inf: running count:%d",count);
    }
  }
}


/**
  * @brief  SystemClock_Config HSI/2 to PLL*12 sysclk 48M
  * @param  None
  * @retval None
  */
void sysclk_init(void) {
  MS32_RCC_OscInitTypeDef osc_cfg;
  MS32_RCC_PllInitTypeDef pll_cfg;
  MS32_RCC_ClkInitTypeDef clk_cfg;

  // get and clear reset flag 
  MS32_RCC_GetResetFlag(ENABLE);
  
  // osc config 
  osc_cfg.HSIState = MS32_RCC_HSI_ON;
  osc_cfg.HSEState = MS32_RCC_HSE_OFF;
  osc_cfg.LSIState = MS32_RCC_LSI_OFF;
//  osc_cfg.LSEState = MS32_RCC_LSE_ON_DRV_H;
  MS32_RCC_OscConfig(&osc_cfg);
  
  // pll config 
  pll_cfg.PLLState  = MS32_RCC_PLL_ON;
  pll_cfg.PLLSource = MS32_RCC_PLL_SOURCE_HSI_DIV_2;       // HSI/2 4M
  pll_cfg.PLLMUL    = MS32_RCC_PLL_MUL12;
  pll_cfg.PREDIV    = MS32_RCC_PLL_PREDIV_DIV1;
  MS32_RCC_PllConfig(&pll_cfg);
  
  // sysclk config 
  clk_cfg.SYSCLKSource   = MS32_RCC_SYSCLK_SOURCE_PLL;
  clk_cfg.AHBCLKDivider  = MS32_RCC_SYSCLK_DIV1;
  clk_cfg.APB1CLKDivider = MS32_RCC_HCLK_DIV1;
  MS32_RCC_ClockConfig(&clk_cfg);
}

/******************************** END OF FILE *********************************/
